[device]
device=mega128
DeviceID=$1E9702
POLL=$FF
HLL=true
PageSize=256
Multiply=true
MOVW=true
LPMinc=true
FlashWrite=true
BOOTRST0=$F000
BOOTRST1=$F800
BOOTRST2=$FC00
BOOTRST3=$FE00
BOOTRSTE=$FFFF
JTAG=true
EEpage=8
enhancedcore=true
boundary=205

[fuses]
fuses=$0B
fusebit0=SUT0
fusebit1=SUT1
fusebit3=EESAVE
fuse05=1
fuse11=0
fuse40=2
rcen=0
eesave=8
ReadLock=true

[fuses_default]
FuseBits0=0
FuseBits1=SPIEN+JTAGEN+OCDEN
FuseBits2=0

[lockbitsWR0]
Adr=0
mask=$3f
cmd=$ACE000C0
0=LOCKBIT1
1=LOCKBIT2
2=BOOTLOCK01
3=BOOTLOCK02
4=BOOTLOCK11
5=BOOTLOCK12

[lockbitsRD0]
Adr=0
Mask=$3f
cmd=$58000000
0=LOCKBIT1
1=LOCKBIT2
2=BOOTLOCK01
3=BOOTLOCK02
4=BOOTLOCK11
5=BOOTLOCK12

[FusebitsWR0]
Adr=0
Mask=$FF
cmd=$ACA00000
0=CKSEL0
1=CKSEL1
2=CKSEL2
3=CKSEL3
4=SUT0
5=SUT1
6=BODEN
7=BODLEVEL

[FusebitsRD0]
Adr=0
Mask=$FF
cmd=$50000000
0=CKSEL0
1=CKSEL1
2=CKSEL2
3=CKSEL3
4=SUT0
5=SUT1
6=BODEN
7=BODLEVEL

[FusebitsWR1]
Adr=0
Mask=$ff
cmd=$ACA80000
0=BOOTRST
1=BOOTSZ0
2=BOOTSZ1
3=EESAVE
4=CKOPT
5=SPIEN
6=JTAGEN
7=OCDEN

[FusebitsRD1]
Adr=0
Mask=$ff
cmd=$58080000
0=BOOTRST
1=BOOTSZ0
2=BOOTSZ1
3=EESAVE
4=CKOPT
5=SPIEN
6=JTAGEN
7=OCDEN

[FusebitsWR2]
Adr=0
Mask=$03
cmd=$ACA40000
0=WDTON
1=M103C

[FusebitsRD2]
Adr=0
Mask=$03
cmd=$50080000
0=WDTON
1=M103C

[Specials0]
Mode=RD
name=Calibration
cmd=$38000000
Mask=$ff
Adr=0
calbytes=4
CalByte0=1MHz
CalByte1=2MHz
CalByte2=4MHz
CalByte3=8MHz

[memory]
datastart=$0
dataend=$1f
idatastart=$0100
idataend=$10ff
pdatastart=32
pdataend=95
eepromstart=$0000
eepromend=$0fff
romtotstart=$0
romtotend=$1ffff
xdata=true

[stack]
stackptrsize=16
StackStart=0
StackEnd=0
FrameEnd=18
PCsize=16

[controlregs_W]
tcnt3=$88
ocr3a=$86
ocr3b=$84
ocr3c=$82
icr3=$80
ocr1c=$78
tcnt1=$4c
ocr1a=$4a
ocr1b=$48
icr1=$46
eear=$3e
adc=$24

[controlregs]
ucsr1c=$9d
udr2=$9c
usr2=$9b
ucsr1a=$9b
ucsr1b=$9a
ucr2=$9a
ubrr1l=$99
ubrr2=$99
ubrr1h=$98
ucsr0c=$95
ucsrc=$95
ubrr0h=$90
ubrrh=$90
tccr3c=$8c
tccr3a=$8b
tccr3b=$8a
tcnt3h=$89
tcnt3l=$88
ocr3ah=$87
ocr3al=$86
ocr3bh=$85
ocr3bl=$84
ocr3ch=$83
ocr3cl=$82
icr3h=$81
icr3l=$80
etimsk=$7d
etifr=$7c
tccr1c=$7a
ocr1ch=$79
ocr1cl=$78
twcr=$74
twdr=$73
twar=$72
twsr=$71
twbr=$70
osccal=$6f
xmcra=$6d
xmcrb=$6c
eicra=$6a
spmcsr=$68
spmcr=$68
portg=$65
ddrg=$64
ping=$63
portf=$62
ddrf=$61
sreg=$5f
sph=$5e
spl=$5d
xdiv=$5c
rampz=$5b
eicr=$5a
eicrb=$5a
eimsk=$59
eifr=$58
timsk=$57
tifr=$56
mcucr=$55
mcucsr=$54
mcusr=$54
tccr0=$53
tccr0a=$53
tcnt0=$52
ocr0=$51
ocr0a=$51
assr=$50
tccr1a=$4f
tccr1b=$4e
tcnt1h=$4d
tcnt1l=$4c
ocr1ah=$4b
ocr1al=$4a
ocr1bh=$49
ocr1bl=$48
icr1h=$47
icr1l=$46
tccr2=$45
tccr2a=$45
tcnt2=$44
ocr2=$43
ocr2a=$43
ocdr=$42
wdtcr=$41
sfior=$40
eearh=$3f
eearl=$3e
eedr=$3d
eecr=$3c
porta=$3b
ddra=$3a
pina=$39
portb=$38
ddrb=$37
pinb=$36
portc=$35
ddrc=$34
pinc=$33
portd=$32
ddrd=$31
pind=$30
spdr=$2f
spsr=$2e
spcr=$2d
udr1=$2c
usr1=$2b
ucsr0a=$2b
ucsr0b=$2a
ucr1=$2a
ubrr1=$29
ubrr0l=$29
acsr=$28
admux=$27
adcsr=$26
adcsra=$26
adch=$25
adcl=$24
porte=$23
ddre=$22
pine=$21
pinf=$20

[controlbits]
as0=8
toie0=1
ocie0=2
ocie0a=2
toie1=4
ocie1b=8
ocie1a=$10
ticie1=$20
toie2=$40
ocie2=$80
ocie2a=$80
toie3=4
TICIE3=$20
ocie3a=$10
ocie3b=$08
ctc0=8
ctc1=8
ctc2=8
ctc3=8
tov0=1
tcn0ub=4
ocr0ub=2
tcr0ub=1

[BootVectors]
ivce=1
ivsel=2
reg=MCUCR

[interruptvectors]
vectormethod=JMP
nrofvectors=35
vectnr0=RESET
vectnr1=INT0
vectnr2=INT1
vectnr3=INT2
vectnr4=INT3
vectnr5=INT4
vectnr6=INT5
vectnr7=INT6
vectnr8=INT7
vectnr9=TIMER2COMP
vectnr10=TIMER2
vectnr11=TIMER1CAPT
vectnr12=TIMER1COMPA
vectnr13=TIMER1COMPB
vectnr14=TIMER1
vectnr15=TIMER0COMP
vectnr16=TIMER0
vectnr17=SPIRDY
vectnr18=RXRDY
vectnr19=UDRE
vectnr20=TXRDY
vectnr21=ADCRDY
vectnr22=EERDY
vectnr23=ACOMP
vectnr24=TIMER1COMPC
vectnr25=TIMER3CAPT
vectnr26=TIMER3COMPA
vectnr27=TIMER3COMPB
vectnr28=TIMER3COMPC
vectnr29=TIMER3
vectnr30=RXRDY2
vectnr31=UDRE2
vectnr32=TXRDY2
vectnr33=TWSI
vectnr34=SPMRDY

[peripheral]
timer0=true
timer1=true
timer2=true
timer3=true
pwm1=true
pwm2=true
pwm3=true
pwm1pin=5
pwm1port=DDRB
pwm2pin=6
pwm2port=DDRB
pwm3pin=7
pwm3port=DDRB
pwm2A=true
pwm2Aport=DDRB
pwm2Apin=7
async=true
async2=true
adc=8
spi=true
spiport=PORTB
spi_ss=0
spi_mosi=2
spi_miso=3
spi_sck=1
CMPPort=PORTE
CMPmask=$0C
mpcm1=1
mpcm=1
I2C=true
USART=true

[timer1]
port=DDRB
oc1a=5
oc1b=6
oc1c=7
Capt=PinD
icp=4

[timer2]
port=DDRB
oc2a=7

[timer3]
port3a=DDRE
port3b=DDRE
port3C=DDRE
oc3a=3
oc3b=4
oc3c=5
Capt=PinE
icp=7

[extint0]
mask=EIMSK
flag=EIFR
bit=0
port=PIND
pin=0

[extint1]
mask=EIMSK
flag=EIFR
bit=1
port=PIND
pin=1

[extint2]
mask=EIMSK
flag=EIFR
bit=2
port=PIND
pin=2

[extint3]
mask=EIMSK
flag=EIFR
bit=3
port=PIND
pin=3

[extint4]
mask=EIMSK
flag=EIFR
bit=4
port=PINE
pin=4

[extint5]
mask=EIMSK
flag=EIFR
bit=5
port=PINE
pin=5

[extint6]
mask=EIMSK
flag=EIFR
bit=6
port=PINE
pin=6

[extint7]
mask=EIMSK
flag=EIFR
bit=7
port=PINE
pin=7

[SysTick]
1=1
2=8
3=32
4=64
5=128
6=256
7=1024

[SysTick2]
1=1
2=8
3=64
4=256
5=1024
6=0
7=0

[JTAGcontrol]
reg=MCUCSR
bit=$80

[JTAGgroups]
PortA=0
PullUpA=0
DDRA=0
PortB=0
PullUpB=0
DDRB=0
PortC=0
PullUpC=0
DDRC=0
PortD=0
PullUpD=0
DDRD=0
PortE=0
PullUpE=0
DDRE=0
PortF=0
PullUpF=0
DDRF=0
PortG=0
PullUpG=0
DDRG=0
ACOMP=0
ADC=0
CLOCK=0
MISC=0

[JTAG_PortA]
PortA_0=14
PortA_1=17
PortA_2=20
PortA_3=23
PortA_4=26
PortA_5=29
PortA_6=32
PortA_7=35

[JTAG_DDRA]
DDRA_0=13
DDRA_1=16
DDRA_2=19
DDRA_3=22
DDRA_4=25
DDRA_5=28
DDRA_6=31
DDRA_7=34

[JTAG_PullUpA]
PullUpA_0=12
PullUpA_1=15
PullUpA_2=18
PullUpA_3=21
PullUpA_4=24
PullUpA_5=27
PullUpA_6=30
PullUpA_7=33

[JTAG_PortB]
PortB_0=135
PortB_1=132
PortB_2=129
PortB_3=126
PortB_4=123
PortB_5=120
PortB_6=117
PortB_7=114

[JTAG_DDRB]
DDRB_0=134
DDRB_1=131
DDRB_2=128
DDRB_3=125
DDRB_4=122
DDRB_5=119
DDRB_6=116
DDRB_7=113

[JTAG_PullUpB]
PullUpB_0=133
PullUpB_1=130
PullUpB_2=127
PullUpB_3=124
PullUpB_4=121
PullUpB_5=118
PullUpB_6=115
PullUpB_7=112

[JTAG_PortC]
PortC_0=62
PortC_1=59
PortC_2=56
PortC_3=53
PortC_4=50
PortC_5=47
PortC_6=44
PortC_7=41

[JTAG_DDRC]
DDRC_0=61
DDRC_1=58
DDRC_2=55
DDRC_3=52
DDRC_4=49
DDRC_5=46
DDRC_6=43
DDRC_7=40

[JTAG_PullUpC]
PullUpC_0=60
PullUpC_1=57
PullUpC_2=54
PullUpC_3=51
PullUpC_4=48
PullUpC_5=45
PullUpC_6=42
PullUpC_7=39

[JTAG_PortD]
PortD_0=92
PortD_1=89
PortD_2=86
PortD_3=83
PortD_4=80
PortD_5=77
PortD_6=74
PortD_7=71

[JTAG_DDRD]
DDRD_0=91
DDRD_1=88
DDRD_2=85
DDRD_3=82
DDRD_4=79
DDRD_5=76
DDRD_6=73
DDRD_7=70

[JTAG_PullUpD]
PullUpD_0=90
PullUpD_1=87
PullUpD_2=84
PullUpD_3=81
PullUpD_4=78
PullUpD_5=75
PullUpD_6=72
PullUpD_7=69

[JTAG_PortE]
PortE_0=159
PortE_1=156
PortE_2=153
PortE_3=150
PortE_4=147
PortE_5=144
PortE_6=141
PortE_7=138

[JTAG_DDRE]
DDRE_0=158
DDRE_1=155
DDRE_2=152
DDRE_3=149
DDRE_4=146
DDRE_5=143
DDRE_6=140
DDRE_7=137

[JTAG_PullUpE]
PullUpE_0=157
PullUpE_1=154
PullUpE_2=151
PullUpE_3=148
PullUpE_4=145
PullUpE_5=142
PullUpE_6=139
PullUpE_7=136

[JTAG_PortF]
PortF_0=2
PortF_1=5
PortF_2=8
PortF_3=11

[JTAG_DDRF]
DDRF_0=1
DDRF_1=4
DDRF_2=7
DDRF_3=10

[JTAG_PullUpF]
PullUpF_0=0
PullUpF_1=3
PullUpF_2=6
PullUpF_3=9

[JTAG_PortG]
PortG_0=68
PortG_1=65
PortG_2=38
PortG_3=111
PortG_4=108

[JTAG_DDRG]
DDRG_0=67
DDRG_1=64
DDRG_2=37
DDRG_3=110
DDRG_4=107

[JTAG_PullUpG]
PullUpG_0=66
PullUpG_1=63
PullUpG_2=36
PullUpG_3=109
PullUpG_4=106

[JTAG_ACOMP]
AC_IDLE=204
ACO=203
ACME=202
AINBG=201

[JTAG_ADC]
COMP=200
ACLK=198
ACTEN=197
ADHSM=196
ADCBGEN=195
ADCEN=194
AMPEN=193
DAC_9=192
DAC_8=191
DAC_7=190
DAC_6=189
DAC_5=188
DAC_4=187
DAC_3=186
DAC_2=185
DAC_1=184
DAC_0=183
EXTCH=182
G10=181
G20=180
GNDEN=179
HOLD=178
IREFEN=177
MUXEN_7=176
MUXEN_6=175
MUXEN_5=174
MUXEN_4=173
MUXEN_3=172
MUXEN_2=171
MUXEN_1=170
MUXEN_0=169
NEGSEL_2=168
NEGSEL_1=167
NEGSEL_0=166
PASSEN=165
PRECH=164
SCTEST=163
ST=162
VCCREN=161

[JTAG_CLOCK]
TOSC=105
TOSCON=104
EXTCLKEN=101
OSCON=100
RCOSCEN=99
OSC32EN=98
EXTCLK=97
OSCCK=96
RCCK=95
OSC32CK=94

[JTAG_MISC]
RESET=103
PEN=160
TWIEN=93

